classification
Title: Windows installer unreadable with std/custom themes
Type: behavior Stage: resolved
Components: Installation, Windows Versions: Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: steve.dower Nosy List: mixmastamyk, python-dev, steve.dower, tim.golden, zach.ware
Priority: normal Keywords:

Created on 2015-05-26 23:59 by mixmastamyk, last changed 2015-05-31 23:41 by steve.dower. This issue is now closed.

Files
File name Uploaded Description Edit
pywin_setup.png mixmastamyk, 2015-05-26 23:59 screen shot
Messages (6)
msg244140 - (view) Author: Mike Miller (mixmastamyk) Date: 2015-05-26 23:59
The new Windows installer displays itself with an HTML (or perhaps skinned) interface with hard-coded white background which does not adhere to the desktop GUI color scheme chosen by the user.

Many times this is only an aesthetic problem, but it may cause the window to be unreadable if the user is using a darker, custom color scheme, or one of the standard Accessible themes such as "High Contrast".  

Invariably the developer/framework sets only one out of two of the background/foreground pair, which I believe happened here.  See attached, the white text is lost on a white background.

Please set both the background/foreground to "system colors" to avoid this issue.  These are available in CSS as well, though not commonly known.
msg244142 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-05-27 03:15
Thanks, good catch.

I'm not entirely sure how we ended up in this state, since the background is actually the system colour and the text is currently hardcoded, but I'll go through and make sure that the system colour indexes are used throughout.

FWIW, it's just plain Win32 UI, nothing special, but it does use some controls that were added in Windows XP and don't get used very often.
msg244143 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2015-05-27 03:46
New changeset a77214dbf1f3 by Steve Dower in branch '3.5':
Issue #24293: Fixes installer colors to use system settings throughout.
https://hg.python.org/cpython/rev/a77214dbf1f3

New changeset 37ed61b1234a by Steve Dower in branch 'default':
Issue #24293: Fixes installer colors to use system settings throughout.
https://hg.python.org/cpython/rev/37ed61b1234a
msg244224 - (view) Author: Mike Miller (mixmastamyk) Date: 2015-05-27 23:18
Thanks.
msg244558 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-05-31 20:31
Reopening this because the lack of a background colour means that the progress text accumulates while installed. I'll get to this sooner or later, but b2 is probably going to have this issue.
msg244564 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2015-05-31 23:40
New changeset c7210097ac90 by Steve Dower in branch '3.5':
Issue #24293: Adds mapping from explicit colours to system colours to correctly handle user themes.
https://hg.python.org/cpython/rev/c7210097ac90
History
Date User Action Args
2015-06-01 13:21:56steve.dowerlinkissue24344 superseder
2015-05-31 23:41:19steve.dowersetstatus: open -> closed
resolution: fixed
stage: resolved
2015-05-31 23:40:45python-devsetmessages: + msg244564
2015-05-31 20:31:37steve.dowersetstatus: closed -> open
resolution: fixed -> (no value)
messages: + msg244558

stage: resolved -> (no value)
2015-05-27 23:18:03mixmastamyksetmessages: + msg244224
2015-05-27 03:47:19steve.dowersetstatus: open -> closed
resolution: fixed
stage: resolved
2015-05-27 03:46:46python-devsetnosy: + python-dev
messages: + msg244143
2015-05-27 03:15:22steve.dowersetassignee: steve.dower
messages: + msg244142
2015-05-26 23:59:00mixmastamykcreate